<html>
<head>
<title>OgrePlatformInformation.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePlatformInformation.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePlatformInformation_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __PlatformInformation_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __PlatformInformation_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>Ogre {
<a name="l00034"></a>00034 <span class="comment">//</span>
<a name="l00035"></a>00035 <span class="comment">// TODO: Puts following macros into OgrePlatform.h?</span>
<a name="l00036"></a>00036 <span class="comment">//</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">/* Initial CPU stuff to set.</span>
<a name="l00039"></a>00039 <span class="comment">*/</span>
<a name="l00040"></a><a class="code" href="OgrePlatformInformation_8h.html#ae606623294d49af88c609d5855ee418b">00040</a> <span class="preprocessor">#define OGRE_CPU_UNKNOWN    0</span>
<a name="l00041"></a><a class="code" href="OgrePlatformInformation_8h.html#a03ad9692ca81e2302d7048c9d7695415">00041</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_CPU_X86        1</span>
<a name="l00042"></a><a class="code" href="OgrePlatformInformation_8h.html#a98616201d2102b59d9d10666f3ce8762">00042</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_CPU_PPC        2</span>
<a name="l00043"></a><a class="code" href="OgrePlatformInformation_8h.html#a87dfb3e6fd0e097cfc22bcf1a936b609">00043</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_CPU_ARM        3</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="comment">/* Find CPU type</span>
<a name="l00046"></a>00046 <span class="comment">*/</span>
<a name="l00047"></a>00047 <span class="preprocessor">#if (defined(_MSC_VER) &amp;&amp; (defined(_M_IX86) || defined(_M_X64))) || \</span>
<a name="l00048"></a>00048 <span class="preprocessor">    (defined(__GNUC__) &amp;&amp; (defined(__i386__) || defined(__x86_64__)))</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_X86</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 <span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE &amp;&amp; defined(__BIG_ENDIAN__)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_PPC</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_X86</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_PLATFORM == OGRE_PLATFORM_APPLE_IOS &amp;&amp; (defined(__i386__) || defined(__x86_64__))</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_X86</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="preprocessor">#elif defined(__arm__)</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_ARM</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00060"></a><a class="code" href="OgrePlatformInformation_8h.html#a719f8e35fd54bc7946246292a772e5cc">00060</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_CPU OGRE_CPU_UNKNOWN</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063 <span class="comment">/* Find how to declare aligned variable.</span>
<a name="l00064"></a>00064 <span class="comment">*/</span>
<a name="l00065"></a>00065 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_MSVC</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ALIGNED_DECL(type, var, alignment)  __declspec(align(alignment)) type var</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 <span class="preprocessor">#elif (OGRE_COMPILER == OGRE_COMPILER_GNUC) || (OGRE_COMPILER == OGRE_COMPILER_CLANG)</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ALIGNED_DECL(type, var, alignment)  type var __attribute__((__aligned__(alignment)))</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>
<a name="l00071"></a>00071 <span class="preprocessor">#else</span>
<a name="l00072"></a><a class="code" href="OgrePlatformInformation_8h.html#af405686ffe3dd6aa1b9683a99e5990ed">00072</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_ALIGNED_DECL(type, var, alignment)  type var</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>
<a name="l00077"></a>00077 <span class="preprocessor">#if OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_SIMD_ALIGNMENT  16</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>
<a name="l00080"></a>00080 <span class="preprocessor">#else</span>
<a name="l00081"></a><a class="code" href="OgrePlatformInformation_8h.html#a30f03b7a029b1b1303e8f816b68c3368">00081</a> <span class="preprocessor"></span><span class="preprocessor">#   define OGRE_SIMD_ALIGNMENT  16</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>
<a name="l00084"></a>00084 <span class="comment">/* Declare variable aligned to SIMD alignment.</span>
<a name="l00085"></a>00085 <span class="comment">*/</span>
<a name="l00086"></a><a class="code" href="OgrePlatformInformation_8h.html#ae6883e4c8b217447e45bdaec1b1465af">00086</a> <span class="preprocessor">#define OGRE_SIMD_ALIGNED_DECL(type, var)   OGRE_ALIGNED_DECL(type, var, OGRE_SIMD_ALIGNMENT)</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00088"></a>00088 <span class="comment">/* Define whether or not Ogre compiled with SSE supports.</span>
<a name="l00089"></a>00089 <span class="comment">*/</span>
<a name="l00090"></a>00090 <span class="preprocessor">#if   OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86 &amp;&amp; OGRE_COMPILER == OGRE_COMPILER_MSVC &amp;&amp; \</span>
<a name="l00091"></a>00091 <span class="preprocessor">    OGRE_PLATFORM != OGRE_PLATFORM_NACL</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_SSE  1</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_X86 &amp;&amp; (OGRE_COMPILER == OGRE_COMPILER_GNUC || OGRE_COMPILER == OGRE_COMPILER_CLANG) &amp;&amp; \</span>
<a name="l00094"></a>00094 <span class="preprocessor">      OGRE_PLATFORM != OGRE_PLATFORM_APPLE_IOS &amp;&amp; OGRE_PLATFORM != OGRE_PLATFORM_NACL</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_SSE  1</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>
<a name="l00098"></a>00098 <span class="comment">/* Define whether or not Ogre compiled with VFP supports.</span>
<a name="l00099"></a>00099 <span class="comment"> */</span>
<a name="l00100"></a>00100 <span class="preprocessor">#if OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_ARM &amp;&amp; (OGRE_COMPILER == OGRE_COMPILER_GNUC || OGRE_COMPILER == OGRE_COMPILER_CLANG) &amp;&amp; defined(__ARM_ARCH_6K__) &amp;&amp; defined(__VFP_FP__)</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_VFP  1</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span>
<a name="l00104"></a>00104 <span class="comment">/* Define whether or not Ogre compiled with NEON supports.</span>
<a name="l00105"></a>00105 <span class="comment"> */</span>
<a name="l00106"></a>00106 <span class="preprocessor">#if OGRE_DOUBLE_PRECISION == 0 &amp;&amp; OGRE_CPU == OGRE_CPU_ARM &amp;&amp; (OGRE_COMPILER == OGRE_COMPILER_GNUC || OGRE_COMPILER == OGRE_COMPILER_CLANG) &amp;&amp; defined(__ARM_ARCH_7A__) &amp;&amp; defined(__ARM_NEON__)</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_NEON  1</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>
<a name="l00110"></a>00110 <span class="preprocessor">#ifndef __OGRE_HAVE_SSE</span>
<a name="l00111"></a><a class="code" href="OgrePlatformInformation_8h.html#ac00688e814459c227d0c68a0f6352da7">00111</a> <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_SSE  0</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>
<a name="l00114"></a>00114 <span class="preprocessor">#ifndef __OGRE_HAVE_VFP</span>
<a name="l00115"></a><a class="code" href="OgrePlatformInformation_8h.html#a7df14046b42696b67e14aec9141995f9">00115</a> <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_VFP  0</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>
<a name="l00118"></a>00118 <span class="preprocessor">#ifndef __OGRE_HAVE_NEON</span>
<a name="l00119"></a><a class="code" href="OgrePlatformInformation_8h.html#a8e0a27b6fe252308fa9eb6700548a78c">00119</a> <span class="preprocessor"></span><span class="preprocessor">#   define __OGRE_HAVE_NEON  0</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>    
<a name="l00143"></a><a class="code" href="classOgre_1_1PlatformInformation.html">00143</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PlatformInformation.html" title="Class which provides the run-time platform information Ogre runs on.">PlatformInformation</a>
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145     <span class="keyword">public</span>:
<a name="l00146"></a>00146 
<a name="l00148"></a><a class="code" href="classOgre_1_1PlatformInformation.html#af7f9306631264031789d89af0642a807">00148</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1PlatformInformation.html#af7f9306631264031789d89af0642a807" title="Enum describing the different CPU features we want to check for, platform-dependent.">CpuFeatures</a>
<a name="l00149"></a>00149         {
<a name="l00150"></a>00150 <span class="preprocessor">#if OGRE_CPU == OGRE_CPU_X86</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>            CPU_FEATURE_SSE         = 1 &lt;&lt; 0,
<a name="l00152"></a>00152             CPU_FEATURE_SSE2        = 1 &lt;&lt; 1,
<a name="l00153"></a>00153             CPU_FEATURE_SSE3        = 1 &lt;&lt; 2,
<a name="l00154"></a>00154             CPU_FEATURE_MMX         = 1 &lt;&lt; 3,
<a name="l00155"></a>00155             CPU_FEATURE_MMXEXT      = 1 &lt;&lt; 4,
<a name="l00156"></a>00156             CPU_FEATURE_3DNOW       = 1 &lt;&lt; 5,
<a name="l00157"></a>00157             CPU_FEATURE_3DNOWEXT    = 1 &lt;&lt; 6,
<a name="l00158"></a>00158             CPU_FEATURE_CMOV        = 1 &lt;&lt; 7,
<a name="l00159"></a>00159             CPU_FEATURE_TSC         = 1 &lt;&lt; 8,
<a name="l00160"></a>00160             CPU_FEATURE_FPU         = 1 &lt;&lt; 9,
<a name="l00161"></a>00161             CPU_FEATURE_PRO         = 1 &lt;&lt; 10,
<a name="l00162"></a>00162             CPU_FEATURE_HTT         = 1 &lt;&lt; 11,
<a name="l00163"></a>00163 <span class="preprocessor">#elif OGRE_CPU == OGRE_CPU_ARM</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>            CPU_FEATURE_VFP         = 1 &lt;&lt; 12,
<a name="l00165"></a>00165             CPU_FEATURE_NEON        = 1 &lt;&lt; 13,
<a name="l00166"></a>00166 <span class="preprocessor">#endif</span>
<a name="l00167"></a>00167 <span class="preprocessor"></span>
<a name="l00168"></a><a class="code" href="classOgre_1_1PlatformInformation.html#af7f9306631264031789d89af0642a807a1bea16c1677fe68834a2d76b968562d7">00168</a>             CPU_FEATURE_NONE        = 0
<a name="l00169"></a>00169         };
<a name="l00170"></a>00170 
<a name="l00176"></a>00176         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getCpuIdentifier(<span class="keywordtype">void</span>);
<a name="l00177"></a>00177 
<a name="l00183"></a>00183         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> getCpuFeatures(<span class="keywordtype">void</span>);
<a name="l00184"></a>00184 
<a name="l00190"></a>00190         <span class="keyword">static</span> <span class="keywordtype">bool</span> hasCpuFeature(CpuFeatures feature);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00194"></a>00194         <span class="keyword">static</span> <span class="keywordtype">void</span> log(<a class="code" href="classOgre_1_1Log.html">Log</a>* pLog);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196     };
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 <span class="preprocessor">#endif  // __PlatformInformation_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
